# DeathRun 2.5
# Created by isivisi
# This plugin is Open-Source
# Please give credit to original creator if modified!
import es,gamethread,popuplib,weaponstrip,cfglib,playerlib,update,random,usermsg
from es import server_var

# DEBUG
debug = 1
# STATS
es.keygroupload('drstats', '|deathrun/databases')
if es.keygetvalue('drstats', 'def', 'save'):
	placeholder = 0
else:
	es.keygroupcreate('drstats')
	es.keycreate('drstats', 'def')
	es.keysetvalue('drstats', 'def', 'save', '1')
	es.keycreate('drstats', 'wins')
	es.keysetvalue('drstats', 'wins', 'save', '1')
	es.keygroupsave('drstats', '|deathrun/databases')
es.keygroupload('drbans', 'deathrun/databases')
if es.keygetvalue('drbans', 'def', 'save'):
	paceholder = 0
else:
	es.keygroupcreate('drbans')
	es.keycreate('drbans', 'def')
	es.keysetvalue('drbans', 'def', 'save', '1')
	es.keygroupsave('drbans', '|deathrun/databases')
info = es.AddonInfo()
info.name = 'DeathRun 2.5'
info.version = '2.5'
info.buildnumber = '975 unstable release!'
info.basename = 'deathrun'
info.url = ''
info.author = 'isivisi'
info.description = 'Gives your server rounds and other cool features for deathrun!'
es.setinfo('b_deathrun_version', '<version: %s build: %s>'%(info.version, info.buildnumber))
es.makepublic('b_deathrun_version')

es.regcmd('add_admin', 'deathrun/addadmin')
es.regcmd('add_vip', 'deathrun/addvip')
es.regcmd('dr_setvariable', 'deathrun/setvar')
#cfg stuff
config = cfglib.AddonCFG(es.getAddonPath("deathrun") + "/deathrun.cfg")
deathrun_defaultteam    = config.cvar("deathrun_defaultteam",     3, "sets the default team for players")
deathrun_autoupdate   = config.cvar("deathrun_autoupdate",   1, "autoupdates")
deathrun_combinelimit      = config.cvar("deathrun_combinelimit",      3, "Limit your combines!")
deathrun_combinelimit_auto    = config.cvar("deathrun_combinelimit_auto",     0, "Let the server limit your combines!")
deathrun_auto_combine_choose	= config.cvar("deathrun_auto_combine_choose", 1, "the server will choose a random combine if there is none")
deathrun_rebel_winlimit  = config.cvar("deathrun_rebel_winlimit",     15, "limit your wins!")
deathrun_combine_winlimit  = config.cvar("deathrun_combine_winlimit",     15, "limit your wins!")
config.write()
config.execute()
#admin cmds
def makeadmincmd(name, returnblock):
	es.regclientcmd('dr_%s'%name, returnblock)
	es.regcmd('dr_%s'%name, '%s_c'%returnblock)
	es.regsaycmd('!%s'%name, returnblock)
makeadmincmd('restart', 'deathrun/restart')
makeadmincmd('setteam', 'deathrun/setteams')
makeadmincmd('forceteam', 'deathrun/forceteam')
makeadmincmd('reset', 'deathrun/resetall')
makeadmincmd('version', 'deathrun/version')
makeadmincmd('combineban', 'deathrun/combineban')
makeadmincmd('combineunban', 'deathrun/combineunban')

es.forcevalue('mp_forcerespawn', '1')
es.forcevalue('mp_allowspectators', '1.0')
es.forcevalue('mp_respawnwavetime', '1')
admins = []
teams = {}
vips = []
notify_tell = {'rebel_spec': 'You will join #greenRebels#lightgreen at the end of the round.',
'combine_spec': 'You will join #greenCombine#lightgreen at the end of the round',
'combine_limit': 'You cannot go over the combine limit!',
'admin_fail': 'You do not have access to that command!',
'teams_esc': 'Press #greenEscape#lightgreen then select your team!',
'vip_health': 'Vip #green+50#lightgreen health!',
'setteam_noid': 'Player does not exist!',
'setteam_syntax': 'Syntax: dr_setteam <name> <team> Example: dr_setteam isi r (uses: r, c, s for teams)',
'forceteam_syntax': 'Syntax: dr_forceteam <name> <team> Example: dr_forceteam isi r (uses: r, c, s for teams)',
'player_start': 'Type #green!teams#lightgreen to join a team!',
'combineban_notonline': 'player does not exist!',
'combineban_alreadybanned': 'player is already banned from combine!',
'combineban_alreadyunbanned': 'player is already unbanned from combine!',
'combineban_syntax': 'dr_combineban <name>',
'combineunban_syntax': 'dr_combineunban <name>',
'combineban_team': 'you are banned from combine!'}
notify_say = {'rebel_win': 'Rebels Win!',
'combine_win': 'Combine Win!',
'restart_5': 'Restarting in 5',
'restart_4': 'Restarting in 4',
'restart_3': 'Restarting in 3',
'restart_2': 'Restarting in 2',
'restart_1': 'Restarting in 1',
'restart_0': 'Begin!',
'combine_missing': 'Someone please say #green!teams#lightgreen and join combine!',
'combine_back': 'Server has combine, round restarting!',
'rebel_winmap': 'Rebels have reached maximum score!',
'combine_winmap': 'Combine have reached maximum score!',
'sm_error': 'Sourcemod is not installed on this server! nextmap not available!',
'reset_score': 'The scores have been reset!',
'plugin_start': 'has loaded with version ' + server_var['b_deathrun_version']}
variable = {'win': 1,
'count': 1,
'antirebel': 0,
'scoring': 0,
'rebel_score': 0,
'combine_score': 0,
'spec': 0,
'needcombine': 1,
'wintaken': 0,
'forceteam': 0}
if es.getplayercount() > 0:
	for userid in es.getUseridList():
		teams['%s'%userid] = '3'
		es.server.queuecmd('echo [DeathRun] Error player %s has no team! fixing.'%userid)
def getrandomplayer():
	if es.getplayercount(3) > 0:
		counting = 0
		while 1:
			counting += 1
			if counting == 100:
				es.msg('[TEAMSELECTOR] Count not find someone to become a combine!')
				break
			for userid in es.getUseridList():
				if random.randint(1,5) == 3 and es.getplayerteam(userid) == 3:
					if es.keygetvalue('drbans', es.getplayersteamid(userid), 'ban') != '1':
						return userid
						break
def version():
	es.tell(es.getcmduserid(), '%s by isivisi'%server_var['b_deathrun_version'])
def isadmin(userid):
	steamid = es.getplayersteamid(userid)
	if steamid in admins:
		return True
	else:
		return False
def isvip(userid):
	steamid = es.getplayersteamid(userid)
	if steamid in vips:
		return True
	else:
		return False
def addadmin():
	args = es.getargs()
	global admins
	admins.append(args)
	print admins
def addvip():
	args = es.getargs()
	global vips
	vips.append(args)
	print vips
def setteam(userid, team, spawn):
	global teams
	teams['%s'%userid] = team
	if spawn == 1:
		es.cexec(userid, 'jointeam %s'%team)
		es.changeteam(userid, team)
def menuhandler(userid, choice, popupname):
	global teams
	if variable['spec'] == 1:
		if choice == 'r':
			setteam(userid, 3, 0)
			tell_notify(userid, 'rebel_spec')
		elif choice == 'c':
			if es.keygetvalue('drbans', es.getplayersteamid(userid), 'ban'):
				if es.keygetvalue('drbans', es.getplayersteamid(userid), 'ban') == '1':
					tell_notify(userid, 'combineban_team')
					return
			print 'cake'
			if es.getplayercount(2) >= deathrun_combinelimit:
				tell_notify(userid, 'combine_limit')
			else:
				setteam(userid, 2, 0)
				tell_notify(userid, 'combine_spec')
		elif choice == 's':
			setteam(userid, 1, 1)
	else:
		if choice == 'r':
			setteam(userid, 3, 1)
		elif choice == 'c':
			if es.keygetvalue('drbans', es.getplayersteamid(userid), 'ban'):
				if es.keygetvalue('drbans', es.getplayersteamid(userid), 'ban') == '1':
					tell_notify(userid, 'combineban_team')
					return
			print 'cake!'
			if es.getplayercount(2) >= deathrun_combinelimit:
				tell_notify(userid, 'combine_limit')
			else:
				setteam(userid, 2, 1)
		elif choice == 's':
			setteam(userid, 1, 1)
myPopup = popuplib.easymenu('Team_Select',None, menuhandler)
myPopup.settitle("Select Team:")

myPopup.addoption('r', "Rebels")
myPopup.addoption('c', "Combine")
myPopup.addoption('s', "Spec")
es.regcmd('dr_getwins', 'deathrun/getwins', '<returnvar> [userid]')
es.regcmd('dr_setwins', 'deathrun/setwins')
def setwins():
	es.keysetvalue('drstats', 'wins', es.getplayersteamid(es.getargv(1)), es.getargv(2))
def getwins():
	es.set(es.getargv(1), es.keygetvalue('drstats', 'wins', es.getplayersteamid(es.getargv(2))))
def teamwin(teamnumber):
	es.keygroupsave('drstats', '|deathrun/databases')
	for userid in es.getUseridList():
		if '%s'%teams['%s'%userid] == '%s'%teamnumber:
			wins = es.keygetvalue('drstats', 'wins', es.getplayersteamid(userid))
			if wins:
				checkwins = int(wins)
				if checkwins < 0:
					es.keysetvalue('drstats', 'wins', es.getplayersteamid(userid), '0')
				else:
					wins = int(wins)
					wins += 1
					es.keysetvalue('drstats', 'wins', es.getplayersteamid(userid), wins)
			else:
				es.keysetvalue('drstats', 'wins', es.getplayersteamid(userid), '1')
def unload():
	global run
	run = 0
	myPopup.delete()
	es.keygroupsave('drstats', '|deathrun/databases')
	es.keygroupdelete('drstats')
	es.keygroupdelete('drbans')
def es_map_start(ev):
	global variable,admins
	variable['spec'] = 0
	variable['needcombine'] = 1
	variable['win'] = 1
	variable['rebel_score'] = 0
	variable['combine_score'] = 0
	admins = []
	es.server.queuecmd('exec deathrun')
	if deathrun_autoupdate == 1:
		update.check()
def player_say(ev):
	if ev['text'] == '!teams':
		tell_notify(ev['userid'], 'teams_esc')
		myPopup.send(ev['userid'])
		myPopup.send(ev['userid'])
def tell_notify(userid, text):
	es.tell(userid, '#multi', '#green[Deathrun]#lightgreen %s'%notify_tell[text])
def degod(userid):
	if playerlib.getPlayer(userid).isdead == 0:
		playerlib.getPlayer(userid).godmode = False
def undo(userid):
	es.setplayerprop(userid, 'CHL2MP_Player.baseclass.baseclass.localdata.m_vecVelocity[2]', '0')
c = {}
c['limit'] = 5
c['current'] = 0
def player_spawn(ev):
	global variable,deathrun_combinelimit,c
	if '%s'%ev['es_userteam'] != '%s'%teams[ev['userid']] and variable['spec'] == 0:
		es.cexec(ev['userid'], 'jointeam %s'%teams[ev['userid']])
		es.changeteam(ev['userid'], teams[ev['userid']])
		print '[DeathRun] Error! Player %s on rong team! fixing...'%ev['userid']
		return
	if playerlib.getPlayer(ev['userid']).isdead == 0:
		playerlib.getPlayer(ev['userid']).godmode = True
	gamethread.delayed(5, degod, ev['userid'])
	es.setplayerprop(ev["userid"], "CBaseEntity.m_CollisionGroup", "2")
	es.setplayerprop(ev['userid'], 'CHL2MP_Player.baseclass.baseclass.localdata.m_vecVelocity[2]', '500')
	gamethread.delayed(3, undo, ev['userid'])
	if deathrun_combinelimit_auto == 1:
		players = es.getplayercount()
		if players <= 5:
			deathrun_combinelimit = 1
		elif players > 5 and players < 10:
			deathrun_combinelimit = 3
		elif players > 9 and players < 20:
			deathrun_combinelimit = 5
	weaponstrip.removeweps(.5)
	playerlib.getPlayer(ev['userid']).health = 9999
	if isvip(ev['userid']) == False:
		gamethread.delayed(5, sethealth, (ev['userid'], '100'))
	else:
		tell_notify(ev['userid'], 'vip_health')
		gamethread.delayed(5, sethealth, (ev['userid'], '150'))
	if ev['es_userteam'] == '3':
		gamethread.delayed(.6, es.sexec, (ev['userid'], 'use weapon_crowbar'))
	elif ev['es_userteam'] == '2':
		gamethread.delayed(.6, es.sexec, (ev['userid'], 'use weapon_stunstick'))
	if es.getplayercount(2) == 0:
		nocombine = 1
		for combine in es.getUseridList():
			if teams['%s'%combine] == 2:
				nocombine = 0
		if nocombine == 1:
			variable['needcombine'] = 1
			variable['spec'] = 0
			variable['win'] = 0
			variable['scoring'] = 0
			notify('combine_missing')
			if deathrun_auto_combine_choose == 1:
				if es.getplayercount() > 1:
					c['current'] += 1
					c['limit'] = es.getplayercount() + 4
					es.msg('#multi', '#green[DeathRun]#lightgreen A combine will be randomly chosen %s/%s'%(c['current'],c['limit']))
					if c['current'] >= c['limit'] and variable['needcombine'] == 1:
						setteam(getrandomplayer(), 2, 1)
						c['current'] = 0
		else:
			c['current'] = 0
	if variable['needcombine'] == 1:
		for useridz in es.getUseridList():
			if teams['%s'%useridz] == 2:
				notify('combine_back')
				forcesettings()
				restartround()
				variable['needcombine'] = 0
				c['current'] = 0
def forcesettings():
	global variable
	if variable['win'] == 0:
		variable['win'] = 1
		variable['scoring'] = 1
		variable['wintaken'] = 0
def sethealth(userid, health):
	playerlib.getPlayer(userid).health = health
def player_activate(ev):
	global teams,timeSeconds,timeMinutes,timeHours,timeDays
	connected[ev['userid']] = 1
	if es.keygetvalue('drstats', ev['es_steamid'], 'save') == '1':
		timeSeconds[ev['es_steamid']] = es.keygetvalue('drstats', ev['es_steamid'], 'seconds')
		timeMinutes[ev['es_steamid']] = es.keygetvalue('drstats', ev['es_steamid'], 'minutes')
		timeHours[ev['es_steamid']] = es.keygetvalue('drstats', ev['es_steamid'], 'hours')
		timeDays[ev['es_steamid']] = es.keygetvalue('drstats', ev['es_steamid'], 'days')
		timetick(ev['userid']) #wow this MIGHT make the plugin unstable as fuck!
	else:
		es.keycreate('drstats', ev['es_steamid'])
		es.keysetvalue('drstats', ev['es_steamid'], 'seconds', '1')
		es.keysetvalue('drstats', ev['es_steamid'], 'minutes', '0')
		es.keysetvalue('drstats', ev['es_steamid'], 'hours', '0')
		es.keysetvalue('drstats', ev['es_steamid'], 'days', '0')
		es.keysetvalue('drstats', ev['es_steamid'], 'save', '1')
		timeSeconds[ev['es_steamid']] = 1
		timeMinutes[ev['es_steamid']] = 0
		timeHours[ev['es_steamid']] = 0
		timeDays[ev['es_steamid']] = 0
		es.keygroupsave('drstats', '|deathrun/databases')
		print('[DR] setting time')		
	try:
		if teams[ev['userid']] == 'lol':
			placeholder = 'lol'
	except:
		tell_notify(ev['userid'], 'player_start')
		teams[ev['userid']] = deathrun_defaultteam
def notify(arg):
	es.msg('#multi', '#green[DeathRun]#lightgreen %s' % notify_say[arg])
def restartround():
	global variable
	if variable['count'] == 1:
		es.server.queuecmd('mp_restartgame 4')
		notify('restart_5')
		variable['win'] = 0
		variable['spec'] = 0
		variable['count'] = 0
		gamethread.delayed(1, fx1, 'lol')
		gamethread.delayed(1, notify, 'restart_4')
		gamethread.delayed(2, notify, 'restart_3')
		gamethread.delayed(3, notify, 'restart_2')
		gamethread.delayed(4, notify, 'restart_1')
		gamethread.delayed(4.1, allteamspec, 'lol')
		gamethread.delayed(5, notify, 'restart_0')
		gamethread.delayed(5, loadteams, '0')
		gamethread.delayed(8, finish, '0')
def fx1(lol):
	global variable
	variable['scoring'] = 0
def finish(lol):
	global variable
	if variable['needcombine'] != 1:
		gamethread.delayed(1.5, specdelay, 'lol')
		variable['win'] = 1
		variable['scoring'] = 1
		variable['antirebel'] = 0
	variable['wintaken'] = 0
	variable['count'] = 1
def specdelay(lol):
	global variable
	variable['spec'] = 1
def setvar():
	global variable
	variable[es.getargv(1)] = int(es.getargv(2))
# team loading system
def loadteams(place):
	timedelay = 0
	for userid in es.getUseridList():
		timedelay += .1
		gamethread.delayed(timedelay, teamdelay, userid)
def teamdelay(userid):
	try:
		setteam(userid, teams['%s'%userid], 1)
	except:
		teams['%s'%userid] = deathrun_defaultteam
		setteam(userid, deathrun_defaultteam, 1)
		print '[DeathRun] Team error! fixing.'
def allteamspec(lol):
	for i in es.getUseridList():
		es.changeteam(i, 1)
#
def player_team(ev):
	global teams,variable
	if ev['team'] == '3' and ev['oldteam'] == '2':
		variable['antirebel'] = 1
	if ev['team'] == '2':
		if es.getplayercount(2) > deathrun_combinelimit:
			tell_notify(ev['userid'], 'combine_limit')
			setteam(ev['userid'], ev['oldteam'], 1)
	if variable['spec'] == 1 and variable['forceteam'] == 0:
		es.cexec(ev['userid'], 'jointeam 1')
		es.changeteam(ev['userid'], 1)
	else:
		try:
			if teams[ev['userid']] == 'test':
				placeholder = 'lol'
		except:
			setteam(ev['userid'], deathrun_defaultteam, 1)
def death_setteam(userid):
	es.changeteam(userid, 1)
	es.cexec(userid, 'jointeam 1')
def player_death(ev):
	global variable
	if variable['spec'] == 1 and variable['forceteam'] == 0:
		gamethread.delayed(1, death_setteam, ev['userid'])
	if variable['win'] == 1:
		if variable['wintaken'] == 0:
			if es.getlivingplayercount(2) == 0:
				gamethread.delayed(.5, pd2, 2)
				notify('rebel_win')
				restartround()
				if variable['scoring'] == 1:
					if variable['antirebel'] == 0:
						variable['rebel_score'] += 1
						es.msg('#multi', '#green[DeathRun]#lightgreen Rebels: %s/%s Combine %s/%s'%(variable['rebel_score'], deathrun_rebel_winlimit, variable['combine_score'], deathrun_combine_winlimit))
						if es.getplayercount() > 1:
							teamwin(3)
						if variable['rebel_score'] == deathrun_rebel_winlimit:
							gameend('rebels')
		if variable['wintaken'] == 0:
			if es.getlivingplayercount(3) == 0:
				gamethread.delayed(.5, pd2, 2)
				notify('combine_win')
				restartround()
				if variable['scoring'] == 1:
					if variable['antirebel'] == 0:
						variable['combine_score'] += 1
						es.msg('#multi', '#green[DeathRun]#lightgreen Rebels: %s/%s Combine %s/%s'%(variable['rebel_score'], deathrun_rebel_winlimit, variable['combine_score'], deathrun_combine_winlimit))
						if es.getplayercount() > 1:
							teamwin(2)
						if variable['combine_score'] == deathrun_combine_winlimit:
							gameend('combine')
def pd2(lol):
	if lol == 2:
		variable['wintaken'] = 1
		variable['win'] = 0
	elif lol == 1:
		variable['wintaken'] = 1
def gameend(team):
	if team == 'rebels':
		notify('rebel_winmap')
		if server_var['sm_nextmap'] != '0':
			gamethread.delayed(5, es.server.queuecmd, 'es changelevel server_var(sm_nextmap)')
		else:
			notify('sm_error')
			reset_score()
	if team == 'combine':
		notify('combine_winmap')
		if server_var['sm_nextmap'] != '0':
			gamethread.delayed(5, es.server.queuecmd, 'es changelevel server_var(sm_nextmap)')
		else:
			notify('sm_error')
			reset_score()
def reset_score():
	global variable
	variable['rebel_score'] = 0
	variable['combine_score'] = 0
	notify('reset_score')
def admin_notify(userid, say, tell, tell_userid, team):
	notify_admin = {'restart': 'restarted the round',
	'reset': 'reset the score',
	'setteam': 'set your team to %s'%team,
	'combineban': 'banned you from combine!',
	'combineunban': 'unbanned you from combine!'}
	if tell == 0:
		es.msg('#multi', '#green[DeathRun]#lightgreen Admin #green%s#lightgreen %s'%(es.getplayername(userid), notify_admin[say]))
	else:
		es.tell(tell_userid, '#multi', '#green[DeathRun]#lightgreen Admin %s %s'%(es.getplayername(userid), notify_admin[say]))
def restart():
	if isadmin(es.getcmduserid()) == True:
		admin_notify(es.getcmduserid(), 'restart', 0, es.getcmduserid(), 'team')
		restartround()
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def restart_c():
	restartround()
def resetall_c():
	reset_score()
def resetall():
	if isadmin(es.getcmduserid()) == True:
		admin_notify(es.getcmduserid(), 'reset', 0, es.getcmduserid(), 'team')
		reset_score()
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def setteams():
	if isadmin(es.getcmduserid()) == True:
		if es.getargv(1) and es.getargv(2):
			player_userid = es.getuserid(es.getargv(1))
			if player_userid:
				if es.getargv(2) == 'r':
					setteam(player_userid, 3, 1)
					admin_notify(es.getcmduserid(), 'setteam', 1, player_userid, 'rebels')
				if es.getargv(2) == 'c':
					setteam(player_userid, 2, 1)
					admin_notify(es.getcmduserid(), 'setteam', 1, player_userid, 'combine')
				if es.getargv(2) == 's':
					setteam(player_userid, 1, 1)
					admin_notify(es.getcmduserid(), 'setteam', 1, player_userid, 'spec')
			else:
				tell_notify(es.getcmduserid(), 'setteam_noid')
		else:
			tell_notify(es.getcmduserid(), 'setteam_syntax')
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def setteams_c():
	player_userid = es.getuserid(es.getargv(1))
	if player_userid:
		if es.getargv(2) == 'r':
			setteam(player_userid, 3, 1)
		if es.getargv(2) == 'c':
			setteam(player_userid, 2, 1)
		if es.getargv(2) == 's':
			setteam(player_userid, 1, 1)
def forceteam_c():
	player_userid = es.getuserid(es.getargv(1))
	if player_userid:
		if es.getargv(2) == 'r':
			setteam(player_userid, 3, 1)
		if es.getargv(2) == 'c':
			setteam(player_userid, 2, 1)
		if es.getargv(2) == 's':
			setteam(player_userid, 1, 1)
		variable['forceteam'] = 1
		gamethread.delayed(.5, forceteamfinish, 'lol')
def forceteam():
	global variable
	if isadmin(es.getcmduserid()) == True:
		if es.getargv(1) and es.getargv(2):
			player_userid = es.getuserid(es.getargv(1))
			if player_userid:
				if es.getargv(2) == 'r':
					setteam(player_userid, 3, 1)
					admin_notify(es.getcmduserid(), 'setteam', 1, player_userid, 'rebels')
				if es.getargv(2) == 'c':
					setteam(player_userid, 2, 1)
					admin_notify(es.getcmduserid(), 'setteam', 1, player_userid, 'combine')
				if es.getargv(2) == 's':
					setteam(player_userid, 1, 1)
					admin_notify(es.getcmduserid(), 'setteam', 1, player_userid, 'spec')
				variable['forceteam'] = 1
				gamethread.delayed(.5, forceteamfinish, 'lol')
			else:
				tell_notify(es.getcmduserid(), 'setteam_noid')
		else:
			tell_notify(es.getcmduserid(), 'forceteam_syntax')
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def forceteamfinish(lol):
	global variable
	variable['forceteam'] = 0
def combineban():
	if isadmin(es.getcmduserid()) == True:
		if es.getargs():
			player_userid = es.getuserid(es.getargs())
			if player_userid:
				steamid = es.getplayersteamid(player_userid)
				getbanstatus = es.keygetvalue('drbans', steamid, 'ban')
				if getbanstatus:
					if getbanstatus == '1':
						tell_notify(es.getcmduserid(), 'combineban_alreadybanned')
					else:
						es.keysetvalue('drbans', steamid, 'ban', '1')
						es.keygroupsave('drbans', '|deathrun/databases')
						admin_notify(es.getcmduserid(), 'combineban', 1, player_userid, 0)
				else:
					es.keycreate('drbans', steamid)
					es.keysetvalue('drbans', steamid, 'ban', '1')
					es.keygroupsave('drbans', '|deathrun/databases')
					admin_notify(es.getcmduserid(), 'combineban', 1, player_userid, 0)
			else:
				tell_notify(es.getcmduserid(), 'combineban_notonline')
		else:
			tell_notify(es.getcmduserid(), 'combineban_syntax')
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
def combineunban():
	if isadmin(es.getcmduserid()) == True:
		if es.getargs():
			player_userid = es.getuserid(es.getargs())
			if player_userid:
				steamid = es.getplayersteamid(player_userid)
				getbanstatus = es.keygetvalue('drbans', steamid, 'ban')
				if getbanstatus:
					if getbanstatus == '0':
						tell_notify(es.getcmduserid(), 'combineban_alreadyunbanned')
					else:
						es.keysetvalue('drbans', steamid, 'ban', '0')
						es.keygroupsave('drbans', '|deathrun/databases')
						admin_notify(es.getcmduserid(), 'combineunban', 1, player_userid, '0')
				else:
					tell_notify(es.getcmduserid(), 'combineban_alreadyunbanned')
			else:
				tell_notify(es.getcmduserid(), 'combineban_notonline')
		else:
			tell_notify(es.getcmduserid(), 'combineban_syntax')
	else:
		tell_notify(es.getcmduserid(), 'admin_fail')
#hudsystem beta :D
def displayhud(userid):
	global run
	for i in es.getUseridList():
		usermsg.hudmsg(i, '                 -Scores-\n        Combine: %s  Rebels: %s'%(variable['rebel_score'],variable['combine_score']),0,0.4,-2,255,255,255,255,255,255,255,255,0,0.1,0.1,1.0,0.0)
		usermsg.hudmsg(i, '%s-%s\n%s\nWins: %s\nPlayed for: %sd%sh%sm%ss'%(info.name,info.buildnumber,es.getplayername(i),es.keygetvalue('drstats', 'wins', es.getplayersteamid(i)),timeDays[es.getplayersteamid(i)],timeHours[es.getplayersteamid(i)],timeMinutes[es.getplayersteamid(i)],timeSeconds[es.getplayersteamid(i)]),1,0,-2,255,255,255,255,255,255,255,255,0,0.1,0.1,1.0,0.0)
	if run == 1:
		gamethread.delayed(1, displayhud, 'userid')
connected = {}
timeSeconds = {}
timeMinutes = {}
timeHours = {}
timeDays = {}
def timetick(i):
	global run,timeSeconds,timeMinutes,timeHours,timeDays
	if run == 1:
		if es.keygetvalue('drstats', es.getplayersteamid(i), 'save') == '1':
			seconds = timeSeconds[es.getplayersteamid(i)]
			minutes = timeMinutes[es.getplayersteamid(i)]
			hours = timeHours[es.getplayersteamid(i)]
			days = timeDays[es.getplayersteamid(i)]
			seconds = int(seconds)
			minutes = int(minutes)
			hours = int(hours)
			days = int(days)
			seconds += 1
			if seconds >= 60:
				seconds = 0
				minutes += 1
			if minutes >= 60:
				minutes = 0
				hours += 1
			if hours >= 24:
				hours = 0
				days += 1
			timeSeconds[es.getplayersteamid(i)] = seconds
			timeMinutes[es.getplayersteamid(i)] = minutes
			timeHours[es.getplayersteamid(i)] = hours
			timeDays[es.getplayersteamid(i)] = days
		if connected[i] == 1:
			gamethread.delayed(1, timetick, i)
def player_disconnect(ev):
	connected[ev['userid']] = 0
	es.keysetvalue('drstats', ev['es_steamid'], 'seconds', timeSeconds[ev['es_steamid']])
	es.keysetvalue('drstats', ev['es_steamid'], 'minutes', timeMinutes[ev['es_steamid']])
	es.keysetvalue('drstats', ev['es_steamid'], 'hours', timeHours[ev['es_steamid']])
	es.keysetvalue('drstats', ev['es_steamid'], 'days', timeDays[ev['es_steamid']])
run = 1
displayhud('lol')
notify('plugin_start')
restartround()
if deathrun_autoupdate == 1:
	update.check()
